SbViewVolume Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | List of all members
SbViewVolume Class Reference
Base Classes

The SbViewVolume class is a viewing volume in 3D space.This class contains the necessary information for storing a view volume. It has methods for projection of primitives into the 3D volume from 2D points in the projection plane or vice versa, doing camera transforms, view volume transforms, etc. More...

`#include <Inventor/SbLinear.h>`

## Public Types
enum | ProjectionType { ORTHOGRAPHIC = 0, PERSPECTIVE = 1 }

## Public Member Functions
| SbViewVolume (void)
| ~SbViewVolume (void)
void | getMatrices (SbMatrix &affine, SbMatrix &proj) const
SbMatrix | getMatrix (void) const
SbMatrix | getCameraSpaceMatrix (void) const
void | projectPointToLine (const SbVec2f &pt, SbLine &line) const
void | projectPointToLine (const SbVec2f &pt, SbVec3f &line0, SbVec3f &line1) const
void | projectToScreen (const SbVec3f &src, SbVec3f &dst) const
SbPlane | getPlane (const float distFromEye) const
SbVec3f | getSightPoint (const float distFromEye) const
SbVec3f | getPlanePoint (const float distFromEye, const SbVec2f &normPoint) const
SbRotation | getAlignRotation (SbBool rightAngleOnly=FALSE) const
float | getWorldToScreenScale (const SbVec3f &worldCenter, float normRadius) const
SbVec2f | projectBox (const SbBox3f &box) const
SbViewVolume | narrow (float left, float bottom, float right, float top) const
SbViewVolume | narrow (const SbBox3f &box) const
void | ortho (float left, float right, float bottom, float top, float nearval, float farval)
void | perspective (float fovy, float aspect, float nearval, float farval)
void | frustum (float left, float right, float bottom, float top, float nearval, float farval)
void | rotateCamera (const SbRotation &q)
void | translateCamera (const SbVec3f &v)
SbVec3f | zVector (void) const
SbViewVolume | zNarrow (float nearval, float farval) const
void | scale (float factor)
void | scaleWidth (float ratio)
void | scaleHeight (float ratio)
ProjectionType | getProjectionType (void) const
const SbVec3f & | getProjectionPoint (void) const
const SbVec3f & | getProjectionDirection (void) const
float | getNearDist (void) const
float | getWidth (void) const
float | getHeight (void) const
float | getDepth (void) const
void | print (FILE *fp) const
void | getViewVolumePlanes (SbPlane planes[6]) const
void | transform (const SbMatrix &matrix)
SbVec3f | getViewUp (void) const
SbBool | intersect (const SbVec3f &p) const
SbBool | intersect (const SbVec3f &p0, const SbVec3f &p1, SbVec3f &closestpoint) const
SbBool | intersect (const SbBox3f &box) const
SbBool | outsideTest (const SbPlane &p, const SbVec3f &bmin, const SbVec3f &bmax) const
const SbDPViewVolume & | getDPViewVolume (void) const

## Public Attributes
ProjectionType | type
SbVec3f | projPoint
SbVec3f | projDir
float | nearDist
float | nearToFar
SbVec3f | llf
SbVec3f | lrf
SbVec3f | ulf

## Detailed Description

The SbViewVolume class is a viewing volume in 3D space.

This class contains the necessary information for storing a view volume. It has methods for projection of primitives into the 3D volume from 2D points in the projection plane or vice versa, doing camera transforms, view volume transforms, etc.

See also
  SbViewportRegion

## Member Enumeration Documentation

enum SbViewVolume::ProjectionType

An SbViewVolume instance can represent either an orthogonal projection volume or a perspective projection volume.

See also
  ortho(), perspective(), getProjectionType().

Enumerator
ORTHOGRAPHIC | Orthographic projection.
PERSPECTIVE | Perspective projection.

## Constructor & Destructor Documentation

SbViewVolume::SbViewVolume | ( | void |  | ) |

Constructor. Note that the SbViewVolume instance will be uninitialized until you explicitly call ortho() or perspective().

See also
  ortho(), perspective().

SbViewVolume::~SbViewVolume | ( | void |  | ) |

Destructor.

## Member Function Documentation

void SbViewVolume::getMatrices | ( | SbMatrix & | affine,
|  | SbMatrix & | proj
| ) |  | const

Returns the view volume's affine matrix and projection matrix.

See also
  getMatrix(), getCameraSpaceMatrix()

SbMatrix SbViewVolume::getMatrix | ( | void |  | ) | const

Returns the combined affine and projection matrix.

See also
  getMatrices(), getCameraSpaceMatrix()

SbMatrix SbViewVolume::getCameraSpaceMatrix | ( | void |  | ) | const

Returns a matrix which will translate the view volume camera back to origo, and rotate the camera so it'll point along the negative z axis.

Note that the matrix will not include the rotation necessary to make the camera up vector point along the positive y axis (i.e. camera roll is not accounted for).

See also
  getMatrices(), getMatrix()

void SbViewVolume::projectPointToLine | ( | const SbVec2f & | pt,
|  | SbLine & | line
| ) |  | const

Project the given 2D point from the projection plane into a 3D line.

pt coordinates should be normalized to be within [0, 1].

void SbViewVolume::projectPointToLine | ( | const SbVec2f & | pt,
|  | SbVec3f & | line0,
|  | SbVec3f & | line1
| ) |  | const

Project the given 2D point from the projection plane into two points defining a 3D line. The first point, line0, will be the corresponding point for the projection on the near plane, while line1 will be the line endpoint, lying in the far plane.

void SbViewVolume::projectToScreen | ( | const SbVec3f & | src,
|  | SbVec3f & | dst
| ) |  | const

Project the src point to a normalized set of screen coordinates in the projection plane and place the result in dst.

It is safe to let src and be the same SbVec3f instance.

The z-coordinate of dst is monotonically increasing for points closer to the far plane. Note however that this is not a linear relationship, the dst z-coordinate is calculated as follows:

Orthogonal view: DSTz = (-2 * SRCz - far - near) / (far - near), Perspective view: DSTz = (-SRCz * (far - near) - 2*far*near) / (far - near)

The returned coordinates (dst) are normalized to be in range [0, 1].

SbPlane SbViewVolume::getPlane | ( | const float | distFromEye | ) | const

Returns an SbPlane instance which has a normal vector in the opposite direction of which the camera is pointing. This means the plane will be parallel to the near and far clipping planes.

See also
  getSightPoint()

SbVec3f SbViewVolume::getSightPoint | ( | const float | distFromEye | ) | const

Returns the point on the center line-of-sight from the camera position with the given distance.

See also
  getPlane()

SbVec3f SbViewVolume::getPlanePoint | ( | const float | distFromEye,
|  | const SbVec2f & | normPoint
| ) |  | const

Return the 3D point which projects to normPoint and lies on the plane perpendicular to the camera direction and distFromEye distance away from the camera position.

normPoint should be given in normalized coordinates, where the visible render canvas is covered by the range [0.0, 1.0].

SbRotation SbViewVolume::getAlignRotation | ( | SbBool | rightangleonly = `FALSE` | ) | const

Returns a rotation that aligns an object so that its positive x-axis is to the right and its positive y-axis is up in the view volume.

If rightangleonly is TRUE, it will create a rotation that aligns the x and y-axis with the closest orthogonal axes to right and up.

float SbViewVolume::getWorldToScreenScale | ( | const SbVec3f & | worldCenter,
|  | float | normRadius
| ) |  | const

Given a sphere with center in worldCenter and an initial radius of 1.0, return the scale factor needed to make this sphere have a normRadius radius when projected onto the near clipping plane.

SbVec2f SbViewVolume::projectBox | ( | const SbBox3f & | box | ) | const

Projects the given box onto the projection plane and returns the normalized screen space it occupies.

SbViewVolume SbViewVolume::narrow | ( | float | left,
|  | float | bottom,
|  | float | right,
|  | float | top
| ) |  | const

Returns a narrowed version of the view volume which is within the given [0, 1] normalized coordinates. The coordinates are taken to be corner points of a normalized "view window" on the near clipping plane. I.e.:

SbViewVolume view;
view.ortho(0, 100, 0, 100, 0.1, 1000);
view = view.narrow(0.25, 0.5, 0.75, 1.0);

..will give a view volume with corner points <25, 75> and <50, 100>.

See also
  scale(), scaleWidth(), scaleHeight()

SbViewVolume SbViewVolume::narrow | ( | const SbBox3f & | box | ) | const

Returns a narrowed version of the view volume which is within the given [0, 1] normalized coordinates. The box x and y coordinates are taken to be corner points of a normalized "view window" on the near clipping plane. The box z coordinates are used to adjust the near and far clipping planes, and should be relative to the current clipping planes. A value of 1.0 is at the current near plane. A value of 0.0 is at the current far plane.

void SbViewVolume::ortho | ( | float | left,
|  | float | right,
|  | float | bottom,
|  | float | top,
|  | float | nearval,
|  | float | farval
| ) |  |

Set up the view volume as a rectangular box for orthographic parallel projections.

The line of sight will be along the negative z axis, through the center of the plane defined by the point

    [(right+left)/2, (top+bottom)/2, 0]

See also
  perspective().

void SbViewVolume::perspective | ( | float | fovy,
|  | float | aspect,
|  | float | nearval,
|  | float | farval
| ) |  |

Set up the view volume for perspective projections. The line of sight will be through origo along the negative z axis.

See also
  ortho().

void SbViewVolume::frustum | ( | float | left,
|  | float | right,
|  | float | bottom,
|  | float | top,
|  | float | nearval,
|  | float | farval
| ) |  |

Set up the frustum for perspective projection. This is an alternative to perspective() that lets you specify any kind of view volumes (e.g. off center volumes). It has the same arguments and functionality as the corresponding OpenGL glFrustum() function.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

See also
  perspective()

void SbViewVolume::rotateCamera | ( | const SbRotation & | q | ) |

Rotate the direction which the camera is pointing in.

See also
  translateCamera().

void SbViewVolume::translateCamera | ( | const SbVec3f & | v | ) |

Translate the camera position of the view volume.

See also
  rotateCamera().

SbVec3f SbViewVolume::zVector | ( | void |  | ) | const

Return the vector pointing from the center of the view volume towards the camera. This is just the vector pointing in the opposite direction of getProjectionDirection().

See also
  getProjectionDirection().

SbViewVolume SbViewVolume::zNarrow | ( | float | nearval,
|  | float | farval
| ) |  | const

Return a copy SbViewVolume with narrowed depth by supplying parameters for new near and far clipping planes.

nearval and should be relative to the current clipping planes. A value of 1.0 is at the current near plane. A value of 0.0 is at the current far plane.

See also
  zVector().

void SbViewVolume::scale | ( | float | factor | ) |

Scale width and height of viewing frustum by the given ratio around the projection plane center axis.

See also
  scaleWidth(), scaleHeight().

void SbViewVolume::scaleWidth | ( | float | ratio | ) |

Scale width of viewing frustum by the given ratio around the vertical center axis in the projection plane.

See also
  scale(), scaleHeight().

void SbViewVolume::scaleHeight | ( | float | ratio | ) |

Scale height of viewing frustum by the given ratio around the horizontal center axis in the projection plane.

See also
  scale(), scaleWidth().

SbViewVolume::ProjectionType SbViewVolume::getProjectionType | ( | void |  | ) | const

Return current view volume projection type, which can be either ORTHOGRAPHIC or PERSPECTIVE.

See also
  SbViewVolume::ProjectionType

const SbVec3f & SbViewVolume::getProjectionPoint | ( | void |  | ) | const

Returns the projection point, i.e. the camera position.

const SbVec3f & SbViewVolume::getProjectionDirection | ( | void |  | ) | const

Returns the direction of projection, i.e. the direction the camera is pointing.

See also
  getNearDist().

float SbViewVolume::getNearDist | ( | void |  | ) | const

Returns distance from projection plane to near clipping plane.

See also
  getProjectionDirection().

float SbViewVolume::getWidth | ( | void |  | ) | const

Returns width of viewing frustum in the projection plane.

See also
  getHeight(), getDepth().

float SbViewVolume::getHeight | ( | void |  | ) | const

Returns height of viewing frustum in the projection plane.

See also
  getWidth(), getDepth().

float SbViewVolume::getDepth | ( | void |  | ) | const

Returns depth of viewing frustum, i.e. the distance from the near clipping plane to the far clipping plane.

See also
  getWidth(), getHeight().

void SbViewVolume::print | ( | FILE * | fp | ) | const

Dump the state of this object to the file stream. Only works in debug version of library, method does nothing in an optimized compile.

void SbViewVolume::getViewVolumePlanes | ( | SbPlane | planes[6] | ) | const

Returns the six planes defining the view volume in the following order: left, bottom, right, top, near, far. Plane normals are directed into the view volume.

This method is an extension for Coin, and is not available in the original Open Inventor.

void SbViewVolume::transform | ( | const SbMatrix & | matrix | ) |

Transform the viewing volume by matrix.

SbVec3f SbViewVolume::getViewUp | ( | void |  | ) | const

Returns the view up vector for this view volume. It's a vector which is perpendicular to the projection direction, and parallel and oriented in the same direction as the vector from the lower left corner to the upper left corner of the near plane.

SbBool SbViewVolume::intersect | ( | const SbVec3f & | p | ) | const

Returns TRUE if p is inside the view volume.

Since
  Coin 2.3

SbBool SbViewVolume::intersect | ( | const SbVec3f & | p0,
|  | const SbVec3f & | p1,
|  | SbVec3f & | closestpoint
| ) |  | const

Returns TRUE if the line segment p0, p1 may intersect volume. Be aware that it's not 100% certain that the line segment intersects the volume even if this function returns TRUE.

closestpoint is set to the closest point on the line to the center ray of the view volume.

Since
  Coin 2.3

SbBool SbViewVolume::intersect | ( | const SbBox3f & | box | ) | const

Returns TRUE if box may be inside the view volume.

Since
  Coin 2.3

SbBool SbViewVolume::outsideTest | ( | const SbPlane & | p,
|  | const SbVec3f & | bmin,
|  | const SbVec3f & | bmax
| ) |  | const

Returns TRUE if all eight corner points in bmin, bmax is outside p.

const SbDPViewVolume & SbViewVolume::getDPViewVolume | ( | void |  | ) | const

Returns the double precision version of this view volume.

## Member Data Documentation

SbViewVolume::ProjectionType SbViewVolume::type

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbVec3f SbViewVolume::projPoint

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbVec3f SbViewVolume::projDir

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

float SbViewVolume::nearDist

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

float SbViewVolume::nearToFar

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbVec3f SbViewVolume::llf

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbVec3f SbViewVolume::lrf

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbVec3f SbViewVolume::ulf

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SbViewVolume.h
- SbViewVolume.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.